#!/usr/bin/perl
# Ralf's Chat - a Perl webchat script
# Copyright 1998-2002 Ralf Gueldemeister <ralf@ralfchat.com>
#
# This file is part of Ralf's Chat.
#
# Ralf's Chat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Ralf's Chat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Ralf's Chat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

require "./config.cgi";
require "./shared.cgi";
require "./$lang_dir/$language.cgi";
require "./$html_dir/user_error.cgi";
require "./$html_dir/chatinput.cgi";


# Main Part - DON'T CHANGE ANYTHING HERE!
#
#######################

&action;

# <DBI>
$dbh->disconnect if ($use_dbi);
# </DBI>

exit;

sub action {
	if ($query{'action'} eq "chatinput_html") {
	    &checkpass;
	    &chatinput_html;
	}
	elsif ($query{'action'} eq "postmsg") {
	    &checkpass;
	    # max length = 400 
	    $query{'msg'} = substr($query{'msg'},0,400);

	    if (substr($query{'msg'},0,1) eq "/" ) { # msg = command?
		&command("$query{'msg'}");    
	    } elsif ($query{'msg_to'} ne "") {
		&command("/msg $query{'msg_to'} $query{'msg'}");
	    } else {
		&postmsg("public", $session{'name'}, "", $query{'msg'});
	    }
	    &chatinput_html;
	}
	else {
		&error;
	} 
}

sub select_user {
    print "<SELECT MAXLENGTH=2 NAME=\"msg_to\">";
    print "<OPTION VALUE=\"\">$msg{'tau'}</OPTION>";
    if ($use_dbi) {
# <DBI>
	my $sth = $dbh->prepare("SELECT name FROM $data{'stillalive'} WHERE room = $session{'room'}");
	$sth->execute;
	
	while ($_ = $sth->fetchrow_arrayref) {
	    $points = (length($$_[0]) > 9) ? ".." : "";
	    my $shortnick = substr($$_[0],0,9).$points;
	    $selected = ($query{'msg_to'} and $query{'msg_to'} eq $$_[0] and not $reset_private_msg_select) ? "SELECTED" : "";
	    print "<OPTION $selected VALUE=\"$$_[0]\">$shortnick</OPTION>";
	}
# </DBI>
    } else {
# <NODBI>
	&file_open("stillalive", "<");
	
	my @row;
	while (@row = split(/;;/, <READFILESTILLALIVE>)) {
	    if ($row[12] != $session{'room'}) {
		next;
	    }
	    $points = (length($row[0]) > 9) ? ".." : "";
	    my $shortnick = substr($row[0],0,9).$points;
	    $selected = ($query{'msg_to'} and $query{'msg_to'} eq $row[0] and not $reset_private_msg_select) ? "SELECTED" : "";
	    print "<OPTION $selected VALUE=\"$row[0]\">$shortnick</OPTION>";
	}
	&file_close("stillalive", "<");
# </NODBI>
    }
    print "</SELECT>";
}

sub command { # Kommandoprozedur fuer /cmd ; parameter 0: commandstring
    $_[0] = $_[0]." "; # add trailing space
    $_[0] =~ s/^\///; # remove /
    my @cmdargs = split(/ /, $_[0]);
    my $cmd = lc($cmdargs[0]);
    my $cmdarg = substr($_[0], index($_[0], " ")+1);

    # check userlevel (set in checkpass)
    if ($ul{$cmd} > $userlevel) {
	&postmsg("command", "USERLEVEL", $session{'name'}, "$msg{'ydhtn'} $cmd");
    } elsif ($cmd eq "msg") { # /msg msgto msg
	$cmdarg = substr($cmdarg, index($cmdarg, " ")+1);
	if ($cmdarg =~ /\S/ and $cmdargs[1]) { # if message and recipient not empty
	    &postmsg("private", $session{'name'}, $cmdargs[1], "$cmdarg"); 
	    &postmsg("private_out", $cmdargs[1], $session{'name'}, "$cmdarg");
	}
    } elsif ($cmd eq "help") {
	&help($cmdargs[1]);
    } elsif ($cmd eq "about") {
	&postmsg("command", "ABOUT", $session{'name'}, $about_msg);
    } elsif ($cmd eq "me") {
	&postmsg("me", $session{'name'}, "", $cmdarg);
    } elsif ($cmd eq "users") { # /listnicks
	&list_nicks;
    } elsif ($cmd eq "deluser") { # /deluser nick
	&remove_nick($cmdargs[1]);
    } elsif ($cmd eq "whois") { # /whois nick
	if (&nick_exists($cmdargs[1])) {
	    &userinfo($cmdargs[1]);
	    &postmsg("command", "WHOIS", $session{'name'}, &msgargs($msg{'ui'},[$cmdargs[1],$userinfo{'realname'},$userinfo{'email'},$userinfo{'age'},$userinfo{'city'},$userinfo{'country'},$userinfo{'url'},$userinfo{'stuff'},$userinfo{'photo_url'}]));
	} else {
	    &postmsg("command", "WHOIS", $session{'name'}, &msgargs($msg{'unf'},[$cmdargs[1]]));
	}
    } elsif ($cmd eq "ban") {
	if ($cmdargs[1]) { 
	    &kick_or_ban_nick($cmdargs[1], 2);
	} else { 
	    &banned_list;
	}
    } elsif ($cmd eq "kick") {
	&kick_or_ban_nick($cmdargs[1], 1);
    } elsif ($cmd eq "unban") {
	&unban($cmdargs[1], 2);
    } elsif ($cmd eq "memo") { # /memo memoto memo
	$cmdarg = substr($cmdarg, index($cmdarg, " ")+1);
	&memo($cmdargs[1],$session{'name'}, $cmdarg);
    } elsif ($cmd eq "ip") {
	&ip($cmdargs[1]);
    } elsif ($cmd eq "admin_memo") { # /admin_memo memo
	&admin_memo($session{'name'}, $cmdarg);
    } elsif ($cmd eq "away") { # /away msg
	&away($cmdarg);
    } elsif ($cmd eq "userlevel") { # /userlevel nick level [mpw]
	$cmdargs[2] = abs($cmdargs[2]);
	if ($userlevel > $cmdargs[2] or $cmdargs[3] eq $masterpassword) {
	    &set_ul($cmdargs[1], $cmdargs[2]);
	} else {
	    &postmsg("command", "USERLEVEL", $session{'name'}, $msg{'ydhtn2'});
	}
# EOC
    } else {
	&postmsg("command", "HELP", $session{'name'}, "$msg{'uc'}: $cmd");
    }
}

sub list_nicks {
    my $nicklist = "<TABLE><TR><TD><B>$msg{'usern'}</B></TD><TD><B>$msg{'email'}</B></TD><TD><B>$msg{'co'}</B></TD><TD><B>$msg{'lv'}</B></TD><TD><B>$msg{'cli'}</B></TD><TD><B>$msg{'statu'}</B></TD><TD><B>$msg{'memos'}</B></TD><TD><B>$msg{'userl'}</B></TR>";
    my $nrnicks;
    
    if ($use_dbi) {
# <DBI>
	my $sth = $dbh->prepare("SELECT * FROM $data{'nicks'}");
	$sth->execute;

	my $row;
	while ($row = $sth->fetchrow_hashref) {
	    my $status = $msg{'norma'};
	    $status = $msg{'kicke'} if ($$row{'banlevel'} == 1);
	    $status = $msg{'banne'} if ($$row{'banlevel'} == 2);
	    $nicklist = "$nicklist<TR><TD>$$row{'name'}</TD><TD>$$row{'email'}</TD><TD>".strftime($posting_time_format, localtime($$row{'doc'}))."</TD><TD>".strftime($posting_time_format, localtime($$row{'lvd'}))."</TD><TD>$$row{'ip'}</TD><TD>$status</TD><TD>$$row{'memos'}</TD><TD>$ul_names{$$row{'userlevel'}}</TD></TR>";
	    $nrnicks++;
	}
# </DBI>
    } else {
# <NODBI>
	&file_open("nicks", "<");
	while (<READFILENICKS>) {
	    chomp;
	    my @nick = split(/;;/);
	    my $status = $msg{'norma'};
	    $status = $msg{'kicke'} if ($nick[10] == 1);
	    $status = $msg{'banne'} if ($nick[10] == 2);
	    $nicklist = "$nicklist<TR><TD>$nick[0]</TD><TD>$nick[2]</TD><TD>".strftime($posting_time_format, localtime($nick[3]))."</TD><TD>".strftime($posting_time_format, localtime($nick[4]))."</TD><TD>$nick[11]</TD><TD>$status</TD><TD>$nick[12]</TD><TD>$ul_names{$nick[7]}</TD></TR>";
	    $nrnicks++;
	}
	&file_close("nicks", "<");
# </NODBI>
    }
    
    $nicklist = "$nicklist</TABLE> $msg{'tnou'} $nrnicks";
    &postmsg("command", "USERS", $session{'name'}, $nicklist);
}




sub kick_or_ban_nick { # $_[0] nick to kick/ban, $_[1] banlevel (1=kick, 2=ban)
    if ($_[0] =~ /^ip:/i) {
	if ($use_dbi) {
# <DBI>
	    $dbh->do("DELETE FROM $data{'banned'} WHERE Lower(entry) = Lower('$_[0]')");
	    $dbh->do("INSERT INTO $data{'banned'} VALUES ('$_[0]')");
# </DBI>
	} else {	
# <NODBI>
	    &file_open("banned", "a");
	    print APPENDFILEBANNED "$_[0]\n";
	    &file_close("banned", "a");
# </NODBI>
	}
	&postmsg("command", "BAN", "$session{'name'}",&msgargs($msg{'ipb'},[substr($_[0],3)]));
	return;
    }

    if ($use_dbi) {
# <DBI>
	$dbh->do("UPDATE $data{'nicks'} SET banlevel = $_[1] WHERE Lower(name) = Lower('$_[0]')");
	if ($_[1] == 2) {
	    $dbh->do("DELETE FROM $data{'banned'} WHERE Lower(entry) = Lower('$_[0]')");
	    $dbh->do("INSERT INTO $data{'banned'} VALUES ('$_[0]')");
	}
	# delete session
	$dbh->do("DELETE FROM $data{'stillalive'} WHERE Lower(name) = Lower('$_[0]')");
# </DBI>
    } else {
# <NODBI>
	&file_open("nicks", ">");
	
	while (<READFILENICKS>) {
	    if (/^\Q$_[0]\E;;/i) {
		chomp;
		my @row = split(/;;/);
		$row[10] = $_[1];
		print WRITEFILENICKS join(';;', @row)."\n";
	    } else {
		print WRITEFILENICKS;
	    }
	}
	
	&file_close("nicks", ">");
	
	if ($_[1] == 2) {
	    &file_open("banned", "a");
	    print APPENDFILEBANNED "$_[0]\n";
	    &file_close("banned", "a");
	}

	# delete session

	&file_open("stillalive", ">");	
	while (<READFILESTILLALIVE>) {
	    if (not /^\Q$_[0]\E;;/i) {
		print WRITEFILESTILLALIVE;
	    }
	}
	
	&file_close("stillalive", ">");
# </NODBI>
    }
    # post msg
    if ($_[1] == 1) {
	&postmsg("command", "KICK", "$session{'name'}", "User $_[0] $msg{'kicke'}");
    } elsif ($_[1] == 2) {
	&postmsg("command", "BAN", "$session{'name'}", &msgargs($msg{'ub'},[$_[0]]));
    }

}    

sub banned_list {
    my $banned;
    if ($use_dbi) {
# <DBI>
	my $sth = $dbh->prepare("SELECT entry FROM $data{'banned'}");
	$sth->execute;
	while ($_ = $sth->fetchrow_arrayref) {
	    $banned .= "<BR>$$_[0]";
	}
# </DBI>
    } else {
# <NODBI>
	&file_open("banned", "<");
	while (<READFILEBANNED>) {
	    chomp;
	    $banned .= "<BR>$_";
	}
	&file_close("banned", "<");
# </NODBI>
    }
    &postmsg("command", "BAN", "$session{'name'}",&msgargs($msg{'banne2'},[$banned]));
}

sub unban {
    if ($use_dbi) {
# <DBI>
	$dbh->do("DELETE FROM $data{'banned'} WHERE Lower(entry) = Lower('$_[0]')");
	$dbh->do("UPDATE $data{'nicks'} SET banlevel = 0 WHERE Lower(name) = Lower('$_[0]')");
# </DBI>
    } else {
# <NODBI>
	&file_open("banned", ">");
	while (<READFILEBANNED>) {
	    if (!/^\Q$_[0]\E$/i) {
		print WRITEFILEBANNED;
	    }
	}
	&file_close("banned", ">");

	# set banlevel to 0

	&file_open("nicks", ">");	
	while (<READFILENICKS>) {
	    if (/^\Q$_[0]\E;;/i) {
		chomp;
		my @row = split(/;;/);
		$row[10] = 0;
		print WRITEFILENICKS join(';;', @row)."\n";
	    } else {
		print WRITEFILENICKS;
	    }
	}
	
	&file_close("nicks", ">");
# </NODBI>
    }
    &postmsg("command", "UNBAN", "$session{'name'}","$msg{'user'} $_[0] $msg{'unban'}");
}

sub memo {
    my $memo_msg_to   = $_[0];
    my $memo_msg_from = $_[1];
    my $memo_msg      = &wash_msg($_[2]);
    my $memo_time     = $timestamp;
    if ($use_dbi) {
# <DBI>
	my $sth = $dbh->prepare("UPDATE $data{'nicks'} SET memos = memos + 1 WHERE Lower(name) = Lower('$_[0]')");
	$sth->execute;
	if ($sth->rows < 1) {
	    &postmsg("command", "MEMO", "$session{'name'}","$msg{'user'} $_[0] $msg{'dne'}");
	    return;
	}
	$dbh->do("INSERT INTO $data{'memo'} VALUES ('$memo_msg_to', '$memo_msg_from', '$memo_msg', $memo_time)");
# </DBI>
    } else {
# <NODBI>
	&file_open("nicks", ">");	
	my $userfound;
	while (<READFILENICKS>) {
	    if (/^\Q$_[0]\E;;/i) {
		chomp;
		my @row = split(/;;/);
		$row[12]++;
		$userfound = 1;
		print WRITEFILENICKS join(';;', @row)."\n";
	    } else {
		print WRITEFILENICKS;
	    }
	}
	
	&file_close("nicks", ">");
	
	if (!$userfound) {
		&postmsg("command", "MEMO", "$session{'name'}","$msg{'user'} $_[0] $msg{'dne'}");
		return;
	}

	&file_open("memo", "a");
	print APPENDFILEMEMO "$memo_msg_to;;$memo_msg_from;;$memo_msg;;$memo_time\n";
	&file_close("memo", "a");
# </NODBI>
    }
    &postmsg("command", "MEMO", "$session{'name'}","$msg{'mf'} $_[0] $msg{'wps'}");
}

sub admin_memo {
    my $memo_msg_to = $msg{'au'};
    my $memo_msg_from = $_[0];
    my $memo_msg = $_[1];

    if ($use_dbi) {
# <DBI>
	$dbh->do("UPDATE $data{'nicks'} SET memos = memos + 1");
	my $sth = $dbh->prepare("SELECT name FROM $data{'nicks'}");
	$sth->execute;
	while ($_ = $sth->fetchrow_arrayref) {
	    $dbh->do("INSERT INTO $data{'memo'} VALUES ('$$_[0]', '$memo_msg_from', '$memo_msg', $timestamp)");
	}
# </DBI>
    } else {
# <NODBI>
	&file_open("nicks", ">");
	&file_open("memo", "a");	
	my @row;
	while (<READFILENICKS>) {
	    chomp;
	    @row = split(/;;/);
	    $row[12]++;
	    print WRITEFILENICKS join(';;', @row)."\n";
	    print APPENDFILEMEMO "$row[0];;$memo_msg_from;;$memo_msg;;$timestamp\n";
	}
	
	&file_close("nicks", ">");
	&file_close("memo", "a");
# </NODBI>
    }
    &postmsg("command", "ADMIN_MEMO", "$session{'name'}","$message{'mf'} $memo_msg_to $msg{'wps'}");
}

sub ip {
    my ($ip, $host);
    if ($use_dbi) {
# <DBI>
	my $sth = $dbh->prepare("SELECT ip FROM $data{'nicks'} WHERE Lower(name) = Lower('$_[0]')");
	$sth->execute;
	$ip = ($sth->fetchrow_array)[0];
# </DBI>
    } else {
# <NODBI>
	&file_open("nicks", "<");
	while (<READFILENICKS>) {
	    if (/^\Q$_[0]\E;;/i) {
		$ip = (split(/;;/))[11];
		last;
	    }
	}
	&file_close("nicks", "<");
# </NODBI>
    }
    if ($ip) {
	$host = gethostbyaddr(pack("C4", split(/\./, $ip)), 2);
	&postmsg("command", "IP", "$session{'name'}","$_[0]: $ip ($host)");	
    } else {
	&postmsg("command", "IP", "$session{'name'}",&msgargs($msg{'unf'}, [$_[0]]));	
    }
}

sub select_action {
    if (%actions) {
	print "<SELECT MAXLENGTH=2 NAME=\"selected_action\">";
	print "<OPTION SELECTED VALUE=\"\">Action:</OPTION>";
	while ((my $key, my $value) = each %actions) {
	    print "<OPTION VALUE=\"$key\">$key</OPTION>";
	}
	print "</SELECT>";
    }
}


# handle command /away
sub away { # 0 reason
    &wash_msg($_[0]);
    if ($use_dbi) {
# <DBI>
	my $sth = $dbh->prepare("SELECT away FROM $data{'stillalive'} WHERE Lower(name) = Lower('$session{'name'}')");
	$sth->execute;
	if (($sth->fetchrow_array)[0] == 1) { # set back again
	    &postmsg("command", "AWAY","$session{'name'}","$msg{'yaba'}");
	    &postmsg("command", "AWAY", "", "<B>$session{'name'} $msg{'iba'} $_[0]</B>");
	    $dbh->do("UPDATE $data{'stillalive'} SET away = 0 WHERE Lower(name) = Lower('$session{'name'}')");
	} else { # set away
	    &postmsg("command", "AWAY", "$session{'name'}","$msg{'yana'}");		
	    &postmsg("command", "AWAY", "", "<B>$session{'name'} $msg{'ia'} $_[0]</B>");
	    $dbh->do("UPDATE $data{'stillalive'} SET away = 1 WHERE Lower(name) = Lower('$session{'name'}')");
	}
# </DBI>
    } else {
# <NODBI>
	&file_open("stillalive", ">");
	
	while (<READFILESTILLALIVE>) {
	    if (/^\Q$session{'name'}\E;;/i) {
		chomp;
		my @row = split(/;;/);
		if ($row[2] == 1) { # set back again
		    &postmsg("command", "AWAY","$session{'name'}","$msg{'yaba'}");
		    &postmsg("command", "AWAY", "", "<B>$session{'name'} $msg{'iba'} $_[0]</B>");
		    $row[2] = 0;
		} else { # set away
		    &postmsg("command", "AWAY", "$session{'name'}","$msg{'yana'}");		
		    &postmsg("command", "AWAY", "", "<B>$session{'name'} $msg{'ia'} $_[0]</B>");
		    $row[2] = 1;
		}
		print WRITEFILESTILLALIVE join(';;', @row)."\n";
	    } else {
		print WRITEFILESTILLALIVE;
	    }
	}
	
	&file_close("stillalive", ">");
# </NODBI>
    }
}

# Set Userlevel
sub set_ul { # 0 - nick, 1 - level
    if (not &nick_exists($_[0])) {
	&postmsg("command", "USERLEVEL", "$session{'name'}",&msgargs($msg{'unf'}, [$_[0]]));
	return;
    }
    
    if ($use_dbi) {
# <DBI>
	$dbh->do("UPDATE $data{'nicks'} SET userlevel = $_[1] WHERE Lower(name) = Lower('$_[0]')");
	$dbh->do("UPDATE $data{'stillalive'} SET userlevel = $_[1] WHERE Lower(name) = Lower('$_[0]')");
# </DBI>
    } else {
# <NODBI>
	&file_open("nicks", ">");
		
	while (<READFILENICKS>) {
	    if (/^\Q$_[0]\E;;/i) {
		chomp;
		my @row = split(/;;/);
		$row[7] = $_[1];
		print WRITEFILENICKS join(';;', @row)."\n";
	    } else {
		print WRITEFILENICKS;
	    }
	}
	
	&file_close("nicks", ">");

	&file_open("stillalive", ">");
		
	while (<READFILESTILLALIVE>) {
	    if (/^\Q$_[0]\E;;/i) {
		chomp;
		my @row = split(/;;/);
		$row[3] = $_[1];
		print WRITEFILESTILLALIVE join(';;', @row)."\n";
	    } else {
		print WRITEFILESTILLALIVE;
	    }
	}
	
	&file_close("stillalive", ">");
# </NODBI>
    }

    &postmsg("command", "USERLEVEL", "$session{'name'}",&msgargs($msg{'tuo'},[$_[0], $_[1]]));
    
}

# show help message (for command)
sub help { # 0 - command
    if ($_[0]) { 
	if ($userlevel >= $ul{lc($_[0])}) {
	    &postmsg("command", "HELP", $session{'name'}, $help{lc($_[0])});
	}
    } else {
	my $help_msg = $help{'main'};
	while ((my $key, my $value) = each %ul) {
	    if ($userlevel >= $value) { 
		$help_msg .= "$help{$key}<BR>";
	    }
	}
	&postmsg("command", "HELP", $session{'name'}, $help_msg);
    }
}

# EOF
